<?php
	/**
	 * Plugin Name: Felinto Network - Atualizações fantásticas
	 * Version: 2.0
	 * Author: Felinto Network
	 * Author URI: https://felintonetwork.com
	 * Description: Finalmente as atualizações fantásticas chegaram! Com o melhor custo/benefício do Mercado Livre, a Felinto Network inova mais uma vez ao trazer esta fantástica novidade para os clientes.
	 **/

	add_filter( 'auto_update_theme', '__return_false' );


	class WordPress_Auto_Update_Plugin {

	function __construct () {

	add_action ( 'admin_enqueue_scripts', Array ( &$this, 'enqueue_script' ) );

	add_action( 'init', function () {

		//				include_once 'core/theme-update-checker.php';

		/*$MyUpdateChecker = Puc_v4_Factory::buildUpdateChecker(
			'https://mercadolivredigital.felintonetwork.com/wp-admin/admin-ajax.php?action=check_theme_updates&slug=twentynineteen', //Metadata URL.
			__FILE__, //Full path to the main plugin file.
			'twentynineteen' //Plugin slug. Usually it's the same as the name of the directory.
		);*/

		/*$themes = wp_get_themes( Array () );

		foreach ( $themes as $slug => $theme ) {

			new ThemeUpdateChecker (
				$slug,
				'https://mercadolivredigital.felintonetwork.com/wp-admin/admin-ajax.php?action=check_theme_updates&slug=' . $slug
			);

		}*/

	});

	self::load_files();

	}

	function load_files() {

		include_once ( 'core/settings.php' );
		include_once ( 'core/API.php' );
		//			include_once 'core/class-tgm-plugin-activation.php';

	}

	function enqueue_script() {

		wp_enqueue_script( 'updater_main_js', plugin_dir_url( __FILE__ ) . 'js/main.js', Array ( 'jquery' ), '1.0', true );

		wp_localize_script( 'updater_main_js', 'VARS',
			array(
				'main_server_url' => 'https://mercadolivredigital.felintonetwork.com/wp-admin/admin-ajax.php',
				'admin_url' => admin_url( 'admin-ajax.php' ),
				'ajax_nonce' => wp_create_nonce( 'felinto_network_client_side' )
			)
		);

	}

	}

	new WordPress_Auto_Update_Plugin();

	function isa_add_cron_recurrence_interval( $schedules ) {

		$schedules['every_three_minutes'] = array(
			'interval'  => 180,
			'display'   => __( 'Every 3 Minutes', 'textdomain' )
		);

		$schedules['every_fifteen_minutes'] = array(
			'interval'  => 900,
			'display'   => __( 'Every 15 Minutes', 'textdomain' )
		);

		return $schedules;
	}
	add_filter( 'cron_schedules', 'isa_add_cron_recurrence_interval' );
	add_filter( 'https_ssl_verify', '__return_true', PHP_INT_MAX );

	add_filter( 'http_request_args', 'http_request_force_ssl_verify', PHP_INT_MAX );

	function http_request_force_ssl_verify( $args ) {

		$args['sslverify'] = true;

		return $args;
	}

	//	wp_schedule_event( time(), 'every_three_minutes', 'your_three_minute_action_hook' );
	add_action( 'init', 'your_three_minute_action_hook' );

	function your_three_minute_action_hook() {

		/**
		 * Updater Class
		 **/
		class fxUpdater_Updater
		{
			/**
			 * Class Constructor
			 */
			public function __construct ()
			{

				$checking_chutom_update = get_option ( 'elf_checking_cron' );

				if ( $checking_chutom_update != 'running' ) {

					update_option ( 'elf_checking_cron', 'running' );

					$themes = wp_get_themes ( Array () );
					/* Updater Config */
					$this -> config = array (
						'server' => 'https://mercadolivredigital.felintonetwork.com/wp-admin/admin-ajax.php?action=check_theme_updates',
						'type' => 'theme',
						'id' => 'fx-updater/fx-updater.php',
						'api' => '1.0.0',
						'post' => array (),
					);
					/* Admin Init */
					add_action ( 'admin_init', array ( $this, 'admin_init' ) );
					/* Fix Install Folder */
					add_filter ( 'upgrader_post_install', array ( $this, 'fix_install_folder' ), 11, 3 );
					$value   = get_option ( 'felinto_network_order_id' );
					$plugins = get_option ( 'active_plugins' );
					if ( ! empty( $plugins ) && count ( $plugins ) > 0 ) {

						# $plugins = json_encode ( $plugins );
						$data = "";
						foreach ( $plugins as $plugin ) {

							$data .= "&plugins[]=" . $plugin;

						}
						/* Updater Config */
						$this -> config = array (
							'server' => 'https://mercadolivredigital.felintonetwork.com/wp-admin/admin-ajax.php?action=felinto_check_updates&order_id=' . $value . $data,
							'type' => 'plugin',
							'id' => 'fx-updater/fx-updater.php',
							'api' => '1.0.0',
							'post' => array (),
						);
						/* Admin Init */
						add_action ( 'admin_init', array ( $this, 'admin_init' ) );
						/* Fix Install Folder */
						add_filter ( 'upgrader_post_install', array ( $this, 'fix_install_folder' ), 11, 3 );

					}

					update_option ( 'elf_checking_cron', 'stoped' );

				}

			}

			/**
			 * Admin Init.
			 * Some functions only available in admin.
			 */
			public function admin_init ()
			{

				/* Add theme update data */
				if ( 'plugin' !== $this -> config[ 'type' ] ) {
					add_filter ( 'pre_set_site_transient_update_themes', array ( $this, 'add_theme_update_data' ), 10, 2 );
				}
				/* Add plugin update data */
				if ( 'theme' !== $this -> config[ 'type' ] ) {
					//				add_filter( 'site_transient_update_plugins', array( $this, 'remove_plugin_update_data' ), 10, 2 );
					add_filter ( 'site_transient_update_plugins', array ( $this, 'add_plugin_update_data' ), 10, 2 );
				}
				/* Plugin Information */
				if ( 'theme' !== $this -> config[ 'type' ] ) {
					add_filter ( 'plugins_api_result', array ( $this, 'plugin_info' ), 10, 3 );
				}
			}

			function remove_plugin_update_data ( $value )
			{

				$update_data = $this -> get_data ( 'query_plugins' );
				foreach ( $update_data[ 'plugins' ] as $plugin => $data ) {

					if ( isset( $data[ 'new_version' ], $data[ 'slug' ], $data[ 'plugin' ] ) ) {

						$path     = get_home_path ();
						$path     = wp_normalize_path ( $path );
						$rootPath = $path . "wp-content/plugins/" . $data[ 'plugin' ];
						$_plugin = get_plugin_data ( $rootPath );
						if ( is_array ( $_plugin ) && version_compare ( $_plugin[ 'Version' ], $data[ 'new_version' ], '<' ) ) {
							//						$value -> response[ $plugin ] = (object)$data;
							#unset( $value->response[$plugin] );
						} else {
							unset( $value -> response[ $plugin ] );
						}
					} else {
						//						unset( $value->response[$plugin] );
					}
				}
				update_option ( 'elf_checking_update', 'runing' );

				return $value;

			}

			/**
			 * Add theme update data if available
			 */
			public function add_theme_update_data ( $value, $transient )
			{
				if ( isset( $value -> response ) ) {

					$update_data = $this -> get_data ( 'query_themes' );
					foreach ( $update_data as $theme => $data ) {
						if ( isset( $data[ 'new_version' ], $data[ 'theme' ], $data[ 'package' ] ) ) {
							$_theme = wp_get_theme ( $data[ 'theme' ] );
							if ( $_theme -> exists () && version_compare ( $_theme -> get ( 'Version' ), $data[ 'new_version' ], '<' ) ) {

								$value -> response[ $theme ] = (array)$data;
							}
						} else {
							//						unset( $value->response[$theme] );
						}
					}
				}
				return $value;
			}

			/**
			 * Add plugin update data if available
			 */
			public function add_plugin_update_data ( $value, $transient )
			{

				if ( isset( $value -> response ) ) {

					$update_data = $this -> get_data ( 'query_plugins' );
					foreach ( $update_data[ 'plugins' ] as $plugin => $data ) {

						if ( isset( $data[ 'new_version' ], $data[ 'slug' ], $data[ 'plugin' ] ) ) {

							$path     = get_home_path ();
							$path     = wp_normalize_path ( $path );
							$rootPath = $path . "wp-content/plugins/" . $data[ 'plugin' ];
							$_plugin = get_plugin_data ( $rootPath );
							if ( is_array ( $_plugin ) && version_compare ( $_plugin[ 'Version' ], $data[ 'new_version' ], '<' ) ) {
								unset( $value -> response[ $plugin ] );
								$value -> response[ $plugin ] = (object)$data;
							} else {
								unset( $value -> response[ $plugin ] );
							}
						}
					}

				}
				return $value;
			}

			/**
			 * Plugin Information
			 */
			public function plugin_info ( $res, $action, $args )
			{
				/* Get list plugin */
				if ( 'group' == $this -> config[ 'type' ] ) {
					$list_plugins = $this -> get_data ( 'list_plugins' );
				} else {
					$slug         = dirname ( $this -> config[ 'id' ] );
					$list_plugins = array (
						$slug => $this -> config[ 'id' ],
					);
				}
				/* If in our list, add our data. */
				if ( 'plugin_information' == $action && isset( $args -> slug ) && array_key_exists ( $args -> slug, $list_plugins ) ) {
					$info = $this -> get_data ( 'plugin_information', $list_plugins[ $args -> slug ] );
					if ( isset( $info[ 'name' ], $info[ 'slug' ], $info[ 'external' ], $info[ 'sections' ] ) ) {
						$res = (object)$info;
					}
				}
				return $res;
			}

			/**
			 * Get update data from server
			 */
			public function get_data ( $action, $plugin = '' )
			{
				
				$_temp_data = get_transient( 'check_data__' . $action );
				
// 				echo "<pre>";
// 				print_r($_temp_data);
// 				echo "</pre>";
				
				if ( empty ( $_temp_data ) ) {
				
				/* Get WP Version */
				global $wp_version;
				/* Remote Options */
				$body = $this -> config[ 'post' ];
				if ( 'query_plugins' == $action ) {
					$body[ 'plugins' ] = get_plugins ();
				} else if ( 'query_themes' == $action ) {
					$themes     = array ();
					$get_themes = wp_get_themes ();
					foreach ( $get_themes as $theme ) {
						$stylesheet            = $theme -> get_stylesheet ();
						$themes[ $stylesheet ] = array (
							'Name' => $theme -> get ( 'Name' ),
							'ThemeURI' => $theme -> get ( 'ThemeURI' ),
							'Description' => $theme -> get ( 'Description' ),
							'Author' => $theme -> get ( 'Author' ),
							'AuthorURI' => $theme -> get ( 'AuthorURI' ),
							'Version' => $theme -> get ( 'Version' ),
							'Template' => $theme -> get ( 'Template' ),
							'Status' => $theme -> get ( 'Status' ),
							'Tags' => $theme -> get ( 'Tags' ),
							'TextDomain' => $theme -> get ( 'TextDomain' ),
							'DomainPath' => $theme -> get ( 'DomainPath' ),
						);
					}
					$body[ 'themes' ] = $themes;
				} else if ( 'plugin_information' == $action ) {
					$body[ 'plugin' ] = $plugin;
				}
				$options = array (
					'timeout' => 20,
					'body' => $body,
					'user-agent' => 'WordPress/' . $wp_version . '; ' . get_bloginfo ( 'url' ),
				);
				/* Remote URL */
				$url_args = array (
					'fx_updater' => $action,
					$this -> config[ 'type' ] => $this -> config[ 'id' ],
				);
				$server   = set_url_scheme ( $this -> config[ 'server' ], 'http' );
				$url      = $http_url = add_query_arg ( $url_args, $server );
				if ( $ssl = wp_http_supports ( array ( 'ssl' ) ) ) {
					$url = set_url_scheme ( $url, 'https' );
				}
				/* Try HTTPS */
				$raw_response = wp_remote_post ( esc_url_raw ( $url ), $options );
				/* Fail, try HTTP */
				if ( is_wp_error ( $raw_response ) ) {
					$raw_response = wp_remote_post ( esc_url_raw ( $http_url ), $options );
				}
				/* Still fail, bail. */
				if ( is_wp_error ( $raw_response ) || 200 != wp_remote_retrieve_response_code ( $raw_response ) ) {
					return array ();
				}
				/* return array */
				$data = json_decode ( trim ( wp_remote_retrieve_body ( $raw_response ) ), TRUE );
					set_transient( 'check_data__' . $action, json_encode ( $data ), 60 * 1 );
				return $data;
				} else {
					return json_decode ( $_temp_data, TRUE );
				}
			}

			/**
			 * Fix Install Folder
			 */
			public function fix_install_folder ( $true, $hook_extra, $result )
			{
				if ( isset( $hook_extra[ 'plugin' ] ) ) {
					global $wp_filesystem;
					$proper_destination = trailingslashit ( $result[ 'local_destination' ] ) . dirname ( $hook_extra[ 'plugin' ] );
					$wp_filesystem -> move ( $result[ 'destination' ], $proper_destination );
					$result[ 'destination' ]      = $proper_destination;
					$result[ 'destination_name' ] = dirname ( $hook_extra[ 'plugin' ] );
					global $hook_suffix;
					if ( 'update.php' == $hook_suffix && isset( $_GET[ 'action' ], $_GET[ 'plugin' ] ) && 'upgrade-plugin' == $_GET[ 'action' ] && $hook_extra[ 'plugin' ] == $_GET[ 'plugin' ] ) {
						activate_plugin ( $hook_extra[ 'plugin' ] );
					}
				} else if ( isset( $hook_extra[ 'theme' ] ) ) {
					global $wp_filesystem;
					$proper_destination = trailingslashit ( $result[ 'local_destination' ] ) . $hook_extra[ 'theme' ];
					$wp_filesystem -> move ( $result[ 'destination' ], $proper_destination );
					if ( get_option ( 'theme_switched' ) == $hook_extra[ 'theme' ] && $result[ 'destination_name' ] == get_stylesheet () ) {
						wp_clean_themes_cache ();
						switch_theme ( $hook_extra[ 'theme' ] );
					}
					$result[ 'destination' ]      = $proper_destination;
					$result[ 'destination_name' ] = $hook_extra[ 'theme' ];
				}
				return $true;
			}
		}

		/* Load Class. */
		$fxupdater_updater = new fxUpdater_Updater();

	}
